#! /usr/bin/env python
##
## vi:ts=4:et
##
##---------------------------------------------------------------------------##
##
## Copyright (C) 2002 Markus F.X.J. Oberhumer <mfx@users.sourceforge.net>
## http://py-stablesort.sourceforge.net/
##
## Distributed under the terms of the PSF License Agreement - see the
## file LICENSE.
##
##---------------------------------------------------------------------------##

import sys

if sys.version[:3] < "2.2":
    raise Exception, "need python 2.2 or better"

# update sys.path when running in the build directory
from util import get_sys_path
sys.path = get_sys_path()

import stablesort


# /***********************************************************************
# // new-style class
# ************************************************************************/

class slist(list):
    def sort(self, cmp=None):
        stablesort.sort(self, cmp)
    def __getslice__(self, start, end):
        return self.__class__(list.__getslice__(self, start, end))


# /***********************************************************************
# //
# ************************************************************************/

def test(l, cmp=None):
    ll = l[:]
    if cmp is None:
        ll.sort()
    else:
        ll.sort(cmp)
    print "%-10s" % ll.__class__.__name__, len(l), l, ll


def main(args):
    print "stablesort version %s, %s" % (stablesort.__version__, stablesort.__compile_date__)
    print stablesort.__file__
    test([5,4,3,2,1])
    test(list([5,4,3,2,1]))
    test(slist([5,4,3,2,1]))
    test([1,2,3,4,5], lambda a, b: cmp(b,a))
    test(list([1,2,3,4,5]), lambda a, b: cmp(b,a))
    test(slist([1,2,3,4,5]), lambda a, b: cmp(b,a))
    return 0


if __name__ == "__main__":
    sys.exit(main(sys.argv))

