#! /usr/bin/env python
##
## vi:ts=4:et
##
##---------------------------------------------------------------------------##
##
## Copyright (C) 2002 Markus F.X.J. Oberhumer <mfx@users.sourceforge.net>
## http://py-stablesort.sourceforge.net/
##
## Distributed under the terms of the PSF License Agreement - see the
## file LICENSE.
##
##---------------------------------------------------------------------------##

import sys, string

# update sys.path when running in the build directory
from util import get_sys_path
sys.path = get_sys_path()

import stablesort


# /***********************************************************************
# // a very simple test driver...
# ************************************************************************/

def print_modinfo():
    #print sys.modules
    mod = sys.modules["stablesort"]
    #print mod
    d = mod.__dict__
    for k in d.keys():
        print k, d[k]


def test1(l):
    l1 = l[:]
    l1.sort()
    l2 = l[:]
    stablesort.sort(l2)
    print len(l), l, l1, l2
    assert l1 == l2


def test2(l, cmp):
    l1 = l[:]
    l1.sort(cmp)
    l2 = l[:]
    stablesort.sort(l2, cmp)
    print len(l), l, l1, l2
    assert l1 == l2


l_global = None

def test3_cmp(a, b):
    l_global[0] = 0
    return 0

def test3():
    global l_global
    l_global = [0, 1, 2]
    try:
        l_global.sort(test3_cmp)
    except TypeError:
        pass
    else:
        raise Exception, "expected a type error when modifying a list during sorting"
    try:
        stablesort.sort(l_global, test3_cmp)
    except TypeError:
        pass
    else:
        raise Exception, "expected a type error when modifying a list during sorting"


def main(args):
    # display version information and module documentation
    print "stablesort version %s, %s" % (stablesort.__version__, stablesort.__compile_date__)
    print stablesort.__file__
    print stablesort.__doc__
    test1([5, 4, 3, 2, 1])
    test2([1, 2, 3, 4, 5], lambda a, b: cmp(b,a))
    test3()
    return 0


if __name__ == "__main__":
    sys.exit(main(sys.argv))

